##// END OF EJS Templates
syntax
Unknown -
r299:64acb085a8ee
parent child
Show More
@@ -1,764 +1,765
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45
45
46 # Debian release
46 # Debian release
47 RELEASE=${RELEASE:=jessie}
47 RELEASE=${RELEASE:=jessie}
48
48
49 #Kernel Branch
49 #Kernel Branch
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
51
51
52 # URLs
52 # URLs
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59
59
60 # Build directories
60 # Build directories
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
62 BUILDDIR="${BASEDIR}/build"
62 BUILDDIR="${BASEDIR}/build"
63
63
64 # Prepare date string for default image file name
64 # Prepare date string for default image file name
65 DATE="$(date +%Y-%m-%d)"
65 DATE="$(date +%Y-%m-%d)"
66 if [ -z "$KERNEL_BRANCH" ] ; then
66 if [ -z "$KERNEL_BRANCH" ] ; then
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
68 else
68 else
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
70 fi
70 fi
71
71
72 # Chroot directories
72 # Chroot directories
73 R="${BUILDDIR}/chroot"
73 R="${BUILDDIR}/chroot"
74 ETC_DIR="${R}/etc"
74 ETC_DIR="${R}/etc"
75 LIB_DIR="${R}/lib"
75 LIB_DIR="${R}/lib"
76 BOOT_DIR="${R}/boot/firmware"
76 BOOT_DIR="${R}/boot/firmware"
77 KERNEL_DIR="${R}/usr/src/linux"
77 KERNEL_DIR="${R}/usr/src/linux"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79
79
80 # Firmware directory: Blank if download from github
80 # Firmware directory: Blank if download from github
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82
82
83 # General settings
83 # General settings
84 SET_ARCH=${SET_ARCH}
84 SET_ARCH=${SET_ARCH}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 PASSWORD=${PASSWORD:=raspberry}
86 PASSWORD=${PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 EXPANDROOT=${EXPANDROOT:=true}
90 EXPANDROOT=${EXPANDROOT:=true}
91
91
92 # Keyboard settings
92 # Keyboard settings
93 XKB_MODEL=${XKB_MODEL:=""}
93 XKB_MODEL=${XKB_MODEL:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97
97
98 # Network settings (DHCP)
98 # Network settings (DHCP)
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100
100
101 # Network settings (static)
101 # Network settings (static)
102 NET_ADDRESS=${NET_ADDRESS:=""}
102 NET_ADDRESS=${NET_ADDRESS:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
109
109
110 # APT settings
110 # APT settings
111 APT_PROXY=${APT_PROXY:=""}
111 APT_PROXY=${APT_PROXY:=""}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113
113
114 # Feature settings
114 # Feature settings
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 ENABLE_I2C=${ENABLE_I2C:=false}
116 ENABLE_I2C=${ENABLE_I2C:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
127 ENABLE_WM=${ENABLE_WM:=""}
127 ENABLE_WM=${ENABLE_WM:=""}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
130 USER_NAME=${USER_NAME:="pi"}
130 USER_NAME=${USER_NAME:="pi"}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133
133
134 # SSH settings
134 # SSH settings
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140
140
141 # Advanced settings
141 # Advanced settings
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
154
154
155 # Kernel compilation settings
155 # Kernel compilation settings
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
164
164
165 # Kernel compilation from source directory settings
165 # Kernel compilation from source directory settings
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
170
170
171 # Reduce disk usage settings
171 # Reduce disk usage settings
172 REDUCE_APT=${REDUCE_APT:=true}
172 REDUCE_APT=${REDUCE_APT:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
175 REDUCE_VIM=${REDUCE_VIM:=false}
175 REDUCE_VIM=${REDUCE_VIM:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
180
180
181 # Encrypted filesystem settings
181 # Encrypted filesystem settings
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
187
187
188 # Chroot scripts directory
188 # Chroot scripts directory
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
190
190
191 # Packages required in the chroot build environment
191 # Packages required in the chroot build environment
192 APT_INCLUDES=${APT_INCLUDES:=""}
192 APT_INCLUDES=${APT_INCLUDES:=""}
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
194
194
195 # Packages required for bootstrapping
195 # Packages required for bootstrapping
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
197 MISSING_PACKAGES=""
197 MISSING_PACKAGES=""
198
198
199 # Packages installed for c/c++ build environment in chroot (keep empty)
199 # Packages installed for c/c++ build environment in chroot (keep empty)
200 COMPILER_PACKAGES=""
200 COMPILER_PACKAGES=""
201
201
202 set +x
202 set +x
203
203
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
205 if [ -n "$SET_ARCH" ]
205 if [ -n "$SET_ARCH" ]
206 echo "Setting Architecture specific settings"
206 echo "Setting Architecture specific settings"
207 ##################################
207 ##################################
208 # 64 bit config
208 # 64 bit config
209 ##################################
209 ##################################
210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
211 echo "64 bit mode selected - Setting up enviroment"
211 echo "64 bit mode selected - Setting up enviroment"
212 # 64 bit depended settings
212 # 64 bit depended settings
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
219
219
220 # RPI 3 serie specific settings
220 # RPI 3 serie specific settings
221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
223
223
224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
226 else
226 else
227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
228 exit 1
228 exit 1
229 fi
229 fi
230
230
231 ##################################
231 ##################################
232 # 32 bit config
232 # 32 bit config
233 ##################################
233 ##################################
234 if [ "$SET_ARCH" = 32 ] ; then
234 if [ "$SET_ARCH" = 32 ] ; then
235 echo "32 bit mode selected - Setting up enviroment"
235 echo "32 bit mode selected - Setting up enviroment"
236 #General 32bit configuration
236 #General 32bit configuration
237 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
237 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
238 KERNEL_ARCH=${KERNEL_ARCH:=arm}
238 KERNEL_ARCH=${KERNEL_ARCH:=arm}
239 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
239 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
240
240
241 #Raspberry setting grouped by board compability
241 #Raspberry setting grouped by board compability
242 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
242 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
244 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
244 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
245 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
245 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
246 RELEASE_ARCH=${RELEASE_ARCH:=armel}
246 RELEASE_ARCH=${RELEASE_ARCH:=armel}
247 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
247 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
248 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
248 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
249 elif [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
249 fi
250 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
250 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
251 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
251 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
252 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
252 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
253 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
253 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
254 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
254 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
255 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
255 fi
256 fi
256 fi
257 fi
257
258
258 #Device specific configuration
259 #Device specific configuration
259 case "$RPI_MODEL" in
260 case "$RPI_MODEL" in
260 0)
261 0)
261 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
262 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
262 1)
263 1)
263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
264 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
264 1P)
265 1P)
265 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
266 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
266 2)
267 2)
267 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
268 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
268 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
269 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
269 #Precompiled Kernel rpi2
270 #Precompiled Kernel rpi2
270 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
271 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
271 ;;
272 ;;
272 3)
273 3)
273 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
274 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
274 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
275 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
275 ;;
276 ;;
276 3P)
277 3P)
277 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
278 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
278 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
279 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
279 ;;
280 ;;
280 *)
281 *)
281 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
282 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
282 exit 1
283 exit 1
283 ;;
284 ;;
284 esac
285 esac
285 #SET_ARCH not set
286 #SET_ARCH not set
286 else
287 else
287 echo "error: Please set '32' or '64' as value for SET_ARCH"
288 echo "error: Please set '32' or '64' as value for SET_ARCH"
288 exit 1
289 exit 1
289 fi
290 fi
290
291
291 # Check if the internal wireless interface is supported by the RPi model
292 # Check if the internal wireless interface is supported by the RPi model
292 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
293 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
293 echo "error: The selected Raspberry Pi model has no internal wireless interface"
294 echo "error: The selected Raspberry Pi model has no internal wireless interface"
294 exit 1
295 exit 1
295 else
296 else
296 echo "Raspberry Pi model"
297 echo "Raspberry Pi model"
297 fi
298 fi
298
299
299 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
300 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
300 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
301 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
301 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
302 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
302 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
303 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
303 exit 1
304 exit 1
304 fi
305 fi
305 fi
306 fi
306
307
307 # Add libncurses5 to enable kernel menuconfig
308 # Add libncurses5 to enable kernel menuconfig
308 if [ "$KERNEL_MENUCONFIG" = true ] ; then
309 if [ "$KERNEL_MENUCONFIG" = true ] ; then
309 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
310 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
310 fi
311 fi
311
312
312 # Add ccache compiler cache for (faster) kernel cross (re)compilation
313 # Add ccache compiler cache for (faster) kernel cross (re)compilation
313 if [ "$KERNEL_CCACHE" = true ] ; then
314 if [ "$KERNEL_CCACHE" = true ] ; then
314 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
315 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
315 fi
316 fi
316
317
317 # Add cryptsetup package to enable filesystem encryption
318 # Add cryptsetup package to enable filesystem encryption
318 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
319 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
319 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
320 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
320 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
321 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
321
322
322 if [ -z "$CRYPTFS_PASSWORD" ] ; then
323 if [ -z "$CRYPTFS_PASSWORD" ] ; then
323 echo "error: no password defined (CRYPTFS_PASSWORD)!"
324 echo "error: no password defined (CRYPTFS_PASSWORD)!"
324 exit 1
325 exit 1
325 fi
326 fi
326 ENABLE_INITRAMFS=true
327 ENABLE_INITRAMFS=true
327 fi
328 fi
328
329
329 # Add initramfs generation tools
330 # Add initramfs generation tools
330 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
331 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
331 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
332 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
332 fi
333 fi
333
334
334 # Add device-tree-compiler required for building the U-Boot bootloader
335 # Add device-tree-compiler required for building the U-Boot bootloader
335 if [ "$ENABLE_UBOOT" = true ] ; then
336 if [ "$ENABLE_UBOOT" = true ] ; then
336 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
337 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
337 fi
338 fi
338
339
339 # Check if root SSH (v2) public key file exists
340 # Check if root SSH (v2) public key file exists
340 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
341 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
341 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
342 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
342 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
343 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
343 exit 1
344 exit 1
344 fi
345 fi
345 fi
346 fi
346
347
347 # Check if $USER_NAME SSH (v2) public key file exists
348 # Check if $USER_NAME SSH (v2) public key file exists
348 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
349 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
349 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
350 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
350 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
351 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
351 exit 1
352 exit 1
352 fi
353 fi
353 fi
354 fi
354
355
355 # Check if all required packages are installed on the build system
356 # Check if all required packages are installed on the build system
356 for package in $REQUIRED_PACKAGES ; do
357 for package in $REQUIRED_PACKAGES ; do
357 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
358 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
358 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
359 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
359 fi
360 fi
360 done
361 done
361
362
362 # If there are missing packages ask confirmation for install, or exit
363 # If there are missing packages ask confirmation for install, or exit
363 if [ -n "$MISSING_PACKAGES" ] ; then
364 if [ -n "$MISSING_PACKAGES" ] ; then
364 echo "the following packages needed by this script are not installed:"
365 echo "the following packages needed by this script are not installed:"
365 echo "$MISSING_PACKAGES"
366 echo "$MISSING_PACKAGES"
366
367
367 echo -n "\ndo you want to install the missing packages right now? [y/n] "
368 echo -n "\ndo you want to install the missing packages right now? [y/n] "
368 read confirm
369 read confirm
369 [ "$confirm" != "y" ] && exit 1
370 [ "$confirm" != "y" ] && exit 1
370
371
371 # Make sure all missing required packages are installed
372 # Make sure all missing required packages are installed
372 apt-get -qq -y install ${MISSING_PACKAGES}
373 apt-get -qq -y install ${MISSING_PACKAGES}
373 fi
374 fi
374
375
375 # Check if ./bootstrap.d directory exists
376 # Check if ./bootstrap.d directory exists
376 if [ ! -d "./bootstrap.d/" ] ; then
377 if [ ! -d "./bootstrap.d/" ] ; then
377 echo "error: './bootstrap.d' required directory not found!"
378 echo "error: './bootstrap.d' required directory not found!"
378 exit 1
379 exit 1
379 fi
380 fi
380
381
381 # Check if ./files directory exists
382 # Check if ./files directory exists
382 if [ ! -d "./files/" ] ; then
383 if [ ! -d "./files/" ] ; then
383 echo "error: './files' required directory not found!"
384 echo "error: './files' required directory not found!"
384 exit 1
385 exit 1
385 fi
386 fi
386
387
387 # Check if specified KERNELSRC_DIR directory exists
388 # Check if specified KERNELSRC_DIR directory exists
388 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
389 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
389 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
390 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
390 exit 1
391 exit 1
391 fi
392 fi
392
393
393 # Check if specified UBOOTSRC_DIR directory exists
394 # Check if specified UBOOTSRC_DIR directory exists
394 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
395 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
395 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
396 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
396 exit 1
397 exit 1
397 fi
398 fi
398
399
399 # Check if specified FBTURBOSRC_DIR directory exists
400 # Check if specified FBTURBOSRC_DIR directory exists
400 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
401 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
401 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
402 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
402 exit 1
403 exit 1
403 fi
404 fi
404
405
405 # Check if specified CHROOT_SCRIPTS directory exists
406 # Check if specified CHROOT_SCRIPTS directory exists
406 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
407 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
407 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
408 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
408 exit 1
409 exit 1
409 fi
410 fi
410
411
411 # Check if specified device mapping already exists (will be used by cryptsetup)
412 # Check if specified device mapping already exists (will be used by cryptsetup)
412 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
413 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
413 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
414 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
414 exit 1
415 exit 1
415 fi
416 fi
416
417
417 # Don't clobber an old build
418 # Don't clobber an old build
418 if [ -e "$BUILDDIR" ] ; then
419 if [ -e "$BUILDDIR" ] ; then
419 echo "error: directory ${BUILDDIR} already exists, not proceeding"
420 echo "error: directory ${BUILDDIR} already exists, not proceeding"
420 exit 1
421 exit 1
421 fi
422 fi
422
423
423 # Setup chroot directory
424 # Setup chroot directory
424 mkdir -p "${R}"
425 mkdir -p "${R}"
425
426
426 # Check if build directory has enough of free disk space >512MB
427 # Check if build directory has enough of free disk space >512MB
427 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
428 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
428 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
429 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
429 exit 1
430 exit 1
430 fi
431 fi
431
432
432 set -x
433 set -x
433
434
434 # Call "cleanup" function on various signals and errors
435 # Call "cleanup" function on various signals and errors
435 trap cleanup 0 1 2 3 6
436 trap cleanup 0 1 2 3 6
436
437
437 # Add required packages for the minbase installation
438 # Add required packages for the minbase installation
438 if [ "$ENABLE_MINBASE" = true ] ; then
439 if [ "$ENABLE_MINBASE" = true ] ; then
439 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
440 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
440 fi
441 fi
441
442
442 # Add required locales packages
443 # Add required locales packages
443 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
444 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
444 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
445 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
445 fi
446 fi
446
447
447 # Add parted package, required to get partprobe utility
448 # Add parted package, required to get partprobe utility
448 if [ "$EXPANDROOT" = true ] ; then
449 if [ "$EXPANDROOT" = true ] ; then
449 APT_INCLUDES="${APT_INCLUDES},parted"
450 APT_INCLUDES="${APT_INCLUDES},parted"
450 fi
451 fi
451
452
452 # Add dbus package, recommended if using systemd
453 # Add dbus package, recommended if using systemd
453 if [ "$ENABLE_DBUS" = true ] ; then
454 if [ "$ENABLE_DBUS" = true ] ; then
454 APT_INCLUDES="${APT_INCLUDES},dbus"
455 APT_INCLUDES="${APT_INCLUDES},dbus"
455 fi
456 fi
456
457
457 # Add iptables IPv4/IPv6 package
458 # Add iptables IPv4/IPv6 package
458 if [ "$ENABLE_IPTABLES" = true ] ; then
459 if [ "$ENABLE_IPTABLES" = true ] ; then
459 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
460 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
460 fi
461 fi
461
462
462 # Add openssh server package
463 # Add openssh server package
463 if [ "$ENABLE_SSHD" = true ] ; then
464 if [ "$ENABLE_SSHD" = true ] ; then
464 APT_INCLUDES="${APT_INCLUDES},openssh-server"
465 APT_INCLUDES="${APT_INCLUDES},openssh-server"
465 fi
466 fi
466
467
467 # Add alsa-utils package
468 # Add alsa-utils package
468 if [ "$ENABLE_SOUND" = true ] ; then
469 if [ "$ENABLE_SOUND" = true ] ; then
469 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
470 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
470 fi
471 fi
471
472
472 # Add rng-tools package
473 # Add rng-tools package
473 if [ "$ENABLE_HWRANDOM" = true ] ; then
474 if [ "$ENABLE_HWRANDOM" = true ] ; then
474 APT_INCLUDES="${APT_INCLUDES},rng-tools"
475 APT_INCLUDES="${APT_INCLUDES},rng-tools"
475 fi
476 fi
476
477
477 # Add fbturbo video driver
478 # Add fbturbo video driver
478 if [ "$ENABLE_FBTURBO" = true ] ; then
479 if [ "$ENABLE_FBTURBO" = true ] ; then
479 # Enable xorg package dependencies
480 # Enable xorg package dependencies
480 ENABLE_XORG=true
481 ENABLE_XORG=true
481 fi
482 fi
482
483
483 # Add user defined window manager package
484 # Add user defined window manager package
484 if [ -n "$ENABLE_WM" ] ; then
485 if [ -n "$ENABLE_WM" ] ; then
485 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
486 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
486
487
487 # Enable xorg package dependencies
488 # Enable xorg package dependencies
488 ENABLE_XORG=true
489 ENABLE_XORG=true
489 fi
490 fi
490
491
491 # Add xorg package
492 # Add xorg package
492 if [ "$ENABLE_XORG" = true ] ; then
493 if [ "$ENABLE_XORG" = true ] ; then
493 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
494 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
494 fi
495 fi
495
496
496 # Replace selected packages with smaller clones
497 # Replace selected packages with smaller clones
497 if [ "$ENABLE_REDUCE" = true ] ; then
498 if [ "$ENABLE_REDUCE" = true ] ; then
498 # Add levee package instead of vim-tiny
499 # Add levee package instead of vim-tiny
499 if [ "$REDUCE_VIM" = true ] ; then
500 if [ "$REDUCE_VIM" = true ] ; then
500 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
501 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
501 fi
502 fi
502
503
503 # Add dropbear package instead of openssh-server
504 # Add dropbear package instead of openssh-server
504 if [ "$REDUCE_SSHD" = true ] ; then
505 if [ "$REDUCE_SSHD" = true ] ; then
505 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
506 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
506 fi
507 fi
507 fi
508 fi
508
509
509 if [ "$RELEASE" != "jessie" ] ; then
510 if [ "$RELEASE" != "jessie" ] ; then
510 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
511 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
511 fi
512 fi
512
513
513 # Configure kernel sources if no KERNELSRC_DIR
514 # Configure kernel sources if no KERNELSRC_DIR
514 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
515 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
515 KERNELSRC_CONFIG=true
516 KERNELSRC_CONFIG=true
516 fi
517 fi
517
518
518 # Configure reduced kernel
519 # Configure reduced kernel
519 if [ "$KERNEL_REDUCE" = true ] ; then
520 if [ "$KERNEL_REDUCE" = true ] ; then
520 KERNELSRC_CONFIG=false
521 KERNELSRC_CONFIG=false
521 fi
522 fi
522
523
523 # Execute bootstrap scripts
524 # Execute bootstrap scripts
524 for SCRIPT in bootstrap.d/*.sh; do
525 for SCRIPT in bootstrap.d/*.sh; do
525 head -n 3 "$SCRIPT"
526 head -n 3 "$SCRIPT"
526 . "$SCRIPT"
527 . "$SCRIPT"
527 done
528 done
528
529
529 ## Execute custom bootstrap scripts
530 ## Execute custom bootstrap scripts
530 if [ -d "custom.d" ] ; then
531 if [ -d "custom.d" ] ; then
531 for SCRIPT in custom.d/*.sh; do
532 for SCRIPT in custom.d/*.sh; do
532 . "$SCRIPT"
533 . "$SCRIPT"
533 done
534 done
534 fi
535 fi
535
536
536 # Execute custom scripts inside the chroot
537 # Execute custom scripts inside the chroot
537 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
538 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
538 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
539 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
539 chroot_exec /bin/bash -x <<'EOF'
540 chroot_exec /bin/bash -x <<'EOF'
540 for SCRIPT in /chroot_scripts/* ; do
541 for SCRIPT in /chroot_scripts/* ; do
541 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
542 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
542 $SCRIPT
543 $SCRIPT
543 fi
544 fi
544 done
545 done
545 EOF
546 EOF
546 rm -rf "${R}/chroot_scripts"
547 rm -rf "${R}/chroot_scripts"
547 fi
548 fi
548
549
549 # Remove c/c++ build environment from the chroot
550 # Remove c/c++ build environment from the chroot
550 chroot_remove_cc
551 chroot_remove_cc
551
552
552 # Remove apt-utils
553 # Remove apt-utils
553 if [ "$RELEASE" = "jessie" ] ; then
554 if [ "$RELEASE" = "jessie" ] ; then
554 chroot_exec apt-get purge -qq -y --force-yes apt-utils
555 chroot_exec apt-get purge -qq -y --force-yes apt-utils
555 fi
556 fi
556
557
557 # Generate required machine-id
558 # Generate required machine-id
558 MACHINE_ID=$(dbus-uuidgen)
559 MACHINE_ID=$(dbus-uuidgen)
559 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
560 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
560 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
561 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
561
562
562 # APT Cleanup
563 # APT Cleanup
563 chroot_exec apt-get -y clean
564 chroot_exec apt-get -y clean
564 chroot_exec apt-get -y autoclean
565 chroot_exec apt-get -y autoclean
565 chroot_exec apt-get -y autoremove
566 chroot_exec apt-get -y autoremove
566
567
567 # Unmount mounted filesystems
568 # Unmount mounted filesystems
568 umount -l "${R}/proc"
569 umount -l "${R}/proc"
569 umount -l "${R}/sys"
570 umount -l "${R}/sys"
570
571
571 # Clean up directories
572 # Clean up directories
572 rm -rf "${R}/run/*"
573 rm -rf "${R}/run/*"
573 rm -rf "${R}/tmp/*"
574 rm -rf "${R}/tmp/*"
574
575
575 # Clean up files
576 # Clean up files
576 rm -f "${ETC_DIR}/ssh/ssh_host_*"
577 rm -f "${ETC_DIR}/ssh/ssh_host_*"
577 rm -f "${ETC_DIR}/dropbear/dropbear_*"
578 rm -f "${ETC_DIR}/dropbear/dropbear_*"
578 rm -f "${ETC_DIR}/apt/sources.list.save"
579 rm -f "${ETC_DIR}/apt/sources.list.save"
579 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
580 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
580 rm -f "${ETC_DIR}/*-"
581 rm -f "${ETC_DIR}/*-"
581 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
582 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
582 rm -f "${ETC_DIR}/resolv.conf"
583 rm -f "${ETC_DIR}/resolv.conf"
583 rm -f "${R}/root/.bash_history"
584 rm -f "${R}/root/.bash_history"
584 rm -f "${R}/var/lib/urandom/random-seed"
585 rm -f "${R}/var/lib/urandom/random-seed"
585 rm -f "${R}/initrd.img"
586 rm -f "${R}/initrd.img"
586 rm -f "${R}/vmlinuz"
587 rm -f "${R}/vmlinuz"
587 rm -f "${R}${QEMU_BINARY}"
588 rm -f "${R}${QEMU_BINARY}"
588
589
589 if [ "$ENABLE_QEMU" = true ] ; then
590 if [ "$ENABLE_QEMU" = true ] ; then
590 # Configure qemu compatible kernel
591 # Configure qemu compatible kernel
591 DTB_FILE=vexpress-v2p-ca15_a7.dtb
592 DTB_FILE=vexpress-v2p-ca15_a7.dtb
592 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
593 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
593 KERNEL_DEFCONFIG="vexpress_defconfig"
594 KERNEL_DEFCONFIG="vexpress_defconfig"
594 if [ "$KERNEL_MENUCONFIG" = false ] ; then
595 if [ "$KERNEL_MENUCONFIG" = false ] ; then
595 KERNEL_OLDDEFCONFIG=true
596 KERNEL_OLDDEFCONFIG=true
596 fi
597 fi
597
598
598 # Setup QEMU directory
599 # Setup QEMU directory
599 mkdir "${BASEDIR}/qemu"
600 mkdir "${BASEDIR}/qemu"
600
601
601 # Copy kernel image to QEMU directory
602 # Copy kernel image to QEMU directory
602 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
603 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
603
604
604 # Copy kernel config to QEMU directory
605 # Copy kernel config to QEMU directory
605 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
606 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
606
607
607 # Copy kernel dtbs to QEMU directory
608 # Copy kernel dtbs to QEMU directory
608 for dtb in "${BOOT_DIR}/"*.dtb ; do
609 for dtb in "${BOOT_DIR}/"*.dtb ; do
609 if [ -f "${dtb}" ] ; then
610 if [ -f "${dtb}" ] ; then
610 install_readonly "${dtb}" "${BASEDIR}/qemu/"
611 install_readonly "${dtb}" "${BASEDIR}/qemu/"
611 fi
612 fi
612 done
613 done
613
614
614 # Copy kernel overlays to QEMU directory
615 # Copy kernel overlays to QEMU directory
615 if [ -d "${BOOT_DIR}/overlays" ] ; then
616 if [ -d "${BOOT_DIR}/overlays" ] ; then
616 # Setup overlays dtbs directory
617 # Setup overlays dtbs directory
617 mkdir "${BASEDIR}/qemu/overlays"
618 mkdir "${BASEDIR}/qemu/overlays"
618
619
619 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
620 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
620 if [ -f "${dtb}" ] ; then
621 if [ -f "${dtb}" ] ; then
621 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
622 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
622 fi
623 fi
623 done
624 done
624 fi
625 fi
625
626
626 # Copy u-boot files to QEMU directory
627 # Copy u-boot files to QEMU directory
627 if [ "$ENABLE_UBOOT" = true ] ; then
628 if [ "$ENABLE_UBOOT" = true ] ; then
628 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
629 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
629 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
630 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
630 fi
631 fi
631 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
632 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
632 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
633 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
633 fi
634 fi
634 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
635 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
635 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
636 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
636 fi
637 fi
637 fi
638 fi
638
639
639 # Copy initramfs to QEMU directory
640 # Copy initramfs to QEMU directory
640 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
641 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
641 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
642 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
642 fi
643 fi
643 fi
644 fi
644
645
645 # Calculate size of the chroot directory in KB
646 # Calculate size of the chroot directory in KB
646 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
647 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
647
648
648 # Calculate the amount of needed 512 Byte sectors
649 # Calculate the amount of needed 512 Byte sectors
649 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
650 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
650 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
651 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
651 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
652 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
652
653
653 # The root partition is EXT4
654 # The root partition is EXT4
654 # This means more space than the actual used space of the chroot is used.
655 # This means more space than the actual used space of the chroot is used.
655 # As overhead for journaling and reserved blocks 35% are added.
656 # As overhead for journaling and reserved blocks 35% are added.
656 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
657 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
657
658
658 # Calculate required image size in 512 Byte sectors
659 # Calculate required image size in 512 Byte sectors
659 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
660 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
660
661
661 # Prepare image file
662 # Prepare image file
662 if [ "$ENABLE_SPLITFS" = true ] ; then
663 if [ "$ENABLE_SPLITFS" = true ] ; then
663 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
664 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
664 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
665 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
665 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
666 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
666 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
667 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
667
668
668 # Write firmware/boot partition tables
669 # Write firmware/boot partition tables
669 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
670 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
670 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
671 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
671 EOM
672 EOM
672
673
673 # Write root partition table
674 # Write root partition table
674 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
675 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
675 ${TABLE_SECTORS},${ROOT_SECTORS},83
676 ${TABLE_SECTORS},${ROOT_SECTORS},83
676 EOM
677 EOM
677
678
678 # Setup temporary loop devices
679 # Setup temporary loop devices
679 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
680 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
680 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
681 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
681 else # ENABLE_SPLITFS=false
682 else # ENABLE_SPLITFS=false
682 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
683 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
683 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
684 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
684
685
685 # Write partition table
686 # Write partition table
686 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
687 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
687 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
688 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
688 ${ROOT_OFFSET},${ROOT_SECTORS},83
689 ${ROOT_OFFSET},${ROOT_SECTORS},83
689 EOM
690 EOM
690
691
691 # Setup temporary loop devices
692 # Setup temporary loop devices
692 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
693 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
693 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
694 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
694 fi
695 fi
695
696
696 if [ "$ENABLE_CRYPTFS" = true ] ; then
697 if [ "$ENABLE_CRYPTFS" = true ] ; then
697 # Create dummy ext4 fs
698 # Create dummy ext4 fs
698 mkfs.ext4 "$ROOT_LOOP"
699 mkfs.ext4 "$ROOT_LOOP"
699
700
700 # Setup password keyfile
701 # Setup password keyfile
701 touch .password
702 touch .password
702 chmod 600 .password
703 chmod 600 .password
703 echo -n ${CRYPTFS_PASSWORD} > .password
704 echo -n ${CRYPTFS_PASSWORD} > .password
704
705
705 # Initialize encrypted partition
706 # Initialize encrypted partition
706 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
707 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
707
708
708 # Open encrypted partition and setup mapping
709 # Open encrypted partition and setup mapping
709 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
710 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
710
711
711 # Secure delete password keyfile
712 # Secure delete password keyfile
712 shred -zu .password
713 shred -zu .password
713
714
714 # Update temporary loop device
715 # Update temporary loop device
715 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
716 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
716
717
717 # Wipe encrypted partition (encryption cipher is used for randomness)
718 # Wipe encrypted partition (encryption cipher is used for randomness)
718 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
719 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
719 fi
720 fi
720
721
721 # Build filesystems
722 # Build filesystems
722 mkfs.vfat "$FRMW_LOOP"
723 mkfs.vfat "$FRMW_LOOP"
723 mkfs.ext4 "$ROOT_LOOP"
724 mkfs.ext4 "$ROOT_LOOP"
724
725
725 # Mount the temporary loop devices
726 # Mount the temporary loop devices
726 mkdir -p "$BUILDDIR/mount"
727 mkdir -p "$BUILDDIR/mount"
727 mount "$ROOT_LOOP" "$BUILDDIR/mount"
728 mount "$ROOT_LOOP" "$BUILDDIR/mount"
728
729
729 mkdir -p "$BUILDDIR/mount/boot/firmware"
730 mkdir -p "$BUILDDIR/mount/boot/firmware"
730 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
731 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
731
732
732 # Copy all files from the chroot to the loop device mount point directory
733 # Copy all files from the chroot to the loop device mount point directory
733 rsync -a "${R}/" "$BUILDDIR/mount/"
734 rsync -a "${R}/" "$BUILDDIR/mount/"
734
735
735 # Unmount all temporary loop devices and mount points
736 # Unmount all temporary loop devices and mount points
736 cleanup
737 cleanup
737
738
738 # Create block map file(s) of image(s)
739 # Create block map file(s) of image(s)
739 if [ "$ENABLE_SPLITFS" = true ] ; then
740 if [ "$ENABLE_SPLITFS" = true ] ; then
740 # Create block map files for "bmaptool"
741 # Create block map files for "bmaptool"
741 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
742 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
742 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
743 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
743
744
744 # Image was successfully created
745 # Image was successfully created
745 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
746 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
746 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
747 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
747 else
748 else
748 # Create block map file for "bmaptool"
749 # Create block map file for "bmaptool"
749 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
750 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
750
751
751 # Image was successfully created
752 # Image was successfully created
752 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
753 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
753
754
754 # Create qemu qcow2 image
755 # Create qemu qcow2 image
755 if [ "$ENABLE_QEMU" = true ] ; then
756 if [ "$ENABLE_QEMU" = true ] ; then
756 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
757 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
757 QEMU_SIZE=16G
758 QEMU_SIZE=16G
758
759
759 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
760 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
760 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
761 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
761
762
762 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
763 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
763 fi
764 fi
764 fi
765 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant